<?php
namespace FiloBlu\Rma\Block\Adminhtml\System\Config;

use Magento\Backend\Block\Template\Context;
use Magento\Config\Block\System\Config\Form\Field\FieldArray\AbstractFieldArray;
use Magento\Eav\Model\Config;
use Magento\Sales\Model\ResourceModel\Order\Status\Collection;

class OrderStatus extends AbstractFieldArray
{
    
    /**
     * @var Config $eav_config,
     */
    protected $eav_config;
    /**
     * @var Collection
     */
    private $orderStatusCollection;


    /**
     * OrderStatus constructor.
     * @param Config $eav_config
     * @param Context $context
     * @param Collection $orderStatusCollection
     * @param array $data
     */
    public function __construct(        
        Config $eav_config,
        Context $context,
        Collection $orderStatusCollection,
        array $data = []
    ) {
        $this->eav_config = $eav_config;
        parent::__construct($context, $data);
        $this->orderStatusCollection = $orderStatusCollection;
    }
    
    
    protected function _prepareToRender()
    {
        
        $orderStatus = $this->orderStatusCollection->toOptionArray();
        
        array_unshift($orderStatus,  array('value' => '*', 'label' => __('-- Select --')));


        $orderStatusBlock=$this->getLayout()->createBlock('Magento\Framework\View\Element\Html\Select')
                        ->setId($this->_getCellInputElementId('<%- _id %>','allowed_status'))
                        ->setName($this->_getCellInputElementName('allowed_status'))
                        ->setClass('select')
                        ->setOptions($orderStatus);

        $this->addColumn('allowed_status', array(
            'label' => __('Magento Order Status'),
            'renderer' => $orderStatusBlock
        ));
        
        $this->_addAfter = false;
        $this->_addButtonLabel = __('Add new allowed order status');
    }
 
   
}
